<?php
/*
    Plugin Name: Notifixio.us
    Plugin URI: http://wordpress.org/extend/plugins/notifixious-plugin/
    Description: This plugin allow your blog to send notifications to your followers on Notifixious through the channels they use (Email, SMS, Instant Messaging : MSN, AIM, GTalk, Yahoo! Messenger...). Once activated, please go to <a href="/wp-admin/options-general.php?page=Options%20Notifixious"> to set it up</a>! Finally : don't forget to <a href="/wp-admin/widgets.php">use our Widget</a> as well to allow your users to subscribe to your blog!
    Version: 0.2
    Author: Mathieu BUONOMO
    Author URI: http://www.mathieubuonomo.com
*/
?>
    <?php
/*  Copyright 2008  Mathieu BUONOMO / Notifixious  (email : http://www.notifixio.us)

This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
    */
?>
    <?php

if( !class_exists( 'notifixious' ) ) {
    class notifixious {

        function init_notifixious_widget() {
            register_sidebar_widget(array('Notifixious Widget', 'widgets'), array($this, 'notifixious_widget'));
            register_widget_control(array('Notifixious Widget', 'widgets'), array($this, 'notifixious_widget_control'), 300, 600);
        }

        function notifixious_widget($args) {

            $source_id = get_option('notifixiousSourceId');
            $widget_pre_text = get_option('notifixiousWidgetPreText');

            echo $before_widget;
            if(!($source_id == "" || $source_id < 1))
            {
                echo "<p>";
                echo $widget_pre_text;
                echo "<script src=\"http://notifixio.us/sources/".$source_id."/subscriptions/widget.js\"></script>";
                echo "</p>";
            }
            echo $after_widget;
        }

        function notifixious_widget_control() {
            $source_id = get_option('notifixiousSourceId');

            if(isset($_POST['notifix_widget_submit']))
            {
                // We need to save the notifix_widget_pre_text_id!
                // $widget_pre_text = $_POST['tag-cloud-title'];
                $widget_pre_text = strip_tags(stripslashes($_POST['notifix_widget_pre_text']));
                update_option('notifixiousWidgetPreText',$widget_pre_text, '', 'no');
            }
            else
            {
                $widget_pre_text = get_option('notifixiousWidgetPreText');
                if($widget_pre_text == "")
                {
                    $widget_pre_text = "Notifixious allows you to receive updates from '".get_bloginfo()."' on your AIM, GTalk, MSN, Jabber, Email, SMS... and many other channels!"; 
                }
            }
            if($source_id == "" || $source_id < 1) 
            {
                echo "<p>Please set up <a href='/wp-admin/options-general.php?page=Options%20Notifixious'>Notifixious first</a>.</p>";
            }
            else
            {
                ?>
                <p>
                    <label for="notifix_widget_pre_text">Text to add before the widget:</label>
                    <textarea id="notifix_widget_pre_text_id" name="notifix_widget_pre_text" cols="32" rows="12"><?php echo htmlspecialchars($widget_pre_text, ENT_QUOTES);?></textarea>
                    <input type="hidden" id="notifix_widget_submit" name="notifix_widget_submit" value="1" />
                </p>
                <?php                

        }

    }

    function add_notifixious_header_tag(){
        if(get_option('notifixiousTagName')){
            echo '<meta name="'.get_option('notifixiousTagName').'" content="'.get_option('notifixiousTagContent').'" />';
        }

    }

    function notifix_menu()
    {
        global $wpdb;
        include 'notifix_admin.php';
    }

    function notifix_admin_actions()
    {
        add_options_page("Notifixio.us", "Notifixio.us", 1,"Options Notifixious", array( &$this, 'notifix_menu'));
    }

    function notifixious_install(){
        # Adding options in the database!
        add_option('notifixiousClaimed','0', '', 'yes');
        add_option('notifixiousRegistered','0', '', 'yes');
        add_option('notifixiousLoginValid','0', '', 'yes');
        add_option('notifixiousPassword','0', '', 'yes');
        add_option('notifixiousLogin','0', '', 'yes');
        add_option('notifixiousSourceId','0', '', 'yes');
        add_option('notifixiousWidgetPreText','', '', 'yes');
    }

    function send_request_to_notifixious($id_post)
    {
        $pass = get_option('notifixiouspassword');
        $login = get_option('notifixiouslogin');
        $id = get_option('notifixiousSourceId');
        $post_id = get_post($id_post);
        $title = $post_id->post_title;
        $text = $post_id->post_content;
        $link = $post_id->guid;
        $url = "http://".$login.":".$pass."@notifixio.us/sources/".$id."/events.xml";
        $params = "event[title]=".$title."&event[text]=".$text."&event[link]=".$link;
        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_VERBOSE, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS,$params);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false); 
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false); 
        curl_setopt($ch, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_1);
        curl_setopt($ch, CURLOPT_POST, 1);
        // Go for it!!!
        $result = curl_exec($ch);
        // close curl
        curl_close($ch);
    }
}
}
if( class_exists( 'notifixious' ) ) {
    $cn = new notifixious;
    // Register for activation
    register_activation_hook( __FILE__, array( &$cn, 'notifixious_install' ));
    add_action('admin_menu',  array( &$cn, 'notifix_admin_actions'));
    add_action('publish_post', array( &$cn, 'send_request_to_notifixious'));
    add_action('wp_head', array( &$cn, 'add_notifixious_header_tag'));
    add_action('plugins_loaded', array(&$cn, 'init_notifixious_widget'));    
}
?>